
package com.rjconsultores.ventaboletos.dao.hibernate;

import java.util.List;

import org.hibernate.Criteria;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Repository;

import com.rjconsultores.ventaboletos.dao.EmpresaAsistenciaDeViajeConfigDAO;
import com.rjconsultores.ventaboletos.entidad.EmpresaAsistenciaDeViajeConfig;

@Repository("empresaAsistenciaDeViajeConfigDAO")
public class EmpresaAsistenciaDeViajeConfigHibernateDAO extends
		GenericHibernateDAO<EmpresaAsistenciaDeViajeConfig, Integer> implements EmpresaAsistenciaDeViajeConfigDAO {

	@Autowired
	public EmpresaAsistenciaDeViajeConfigHibernateDAO(@Qualifier("sessionFactory") SessionFactory factory) {
		setSessionFactory(factory);
	}

	@Override
	public List<EmpresaAsistenciaDeViajeConfig> obtenerTodos() {
		Criteria c = getSession().createCriteria(getPersistentClass());
		c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));

		return c.list();
	}

	public EmpresaAsistenciaDeViajeConfig buscarChave(String chave, Integer empresaId) {
		Criteria c = getSession().createCriteria(getPersistentClass());
		c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));

		c.add(Restrictions.eq("chave", chave));
		c.add(Restrictions.eq("empresa.empresaId", empresaId));

		return (EmpresaAsistenciaDeViajeConfig) c.uniqueResult();
	}

	public List<EmpresaAsistenciaDeViajeConfig> buscarByEmpresa(Integer empresaId) {
		Criteria c = getSession().createCriteria(getPersistentClass());
		c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));
		c.add(Restrictions.eq("empresa.empresaId", empresaId));

		return c.list();
	}
}
